require "lope2d"
require "gooi"
require "utils"
candy = require "candy"
k     = require "katsudo"

function love.load()
    gr = love.graphics
    kb = love.keyboard
    mo = love.mouse
    to = love.touch
    ma = love.math
    au = love.audio
    fs = love.filesystem

    fs.setIdentity("the_lord_of_candies")

    -- highscore data:
    local fileNameHS = "records.lord"

    if not fs.exists(fileNameHS) then
        local stringData = "records = {"

        for i = 1, 4 do
            stringData = stringData..
            "    {\n"..
            "        score = 0,\n"..
            "        name = \"---\"".."\n"..
            "    },"
        end

        stringData = stringData.."}"

        local compressedData = ma.compress(stringData, "gzip")

        local writeOK = fs.write("records.lord", compressedData)
    end


    --[[
    local data, size = fs.read("records.lord")
    decompressed = ma.decompress(data, "gzip")

    loadstring(decompressed)()

    print_r(records)
    ]]


    gr.setLineWidth(2)
    gr.setLineStyle("rough")

    colors = {
        black = {0, 0, 0},
        darkGray = {48, 48, 48},
        white = {255, 255, 255},
        almostWhite = {248, 248, 248},
        red = {208, 16, 0},
        green = {0, 104, 0},
        lightGreen = {40, 192, 32},
        softBlue = {80, 120, 248},
        orange = {248, 128, 24},
        gold = {192, 152, 0}
    }

    dirImgs = "/assets/imgs/"
    dirFonts = "/assets/fonts/"
    dirAudio = "/assets/audio/"
    kinds = {"red", "green", "blue"}
    places = {"st", "nd", "rd", "th", "th", "th"}

    win = {w = gr.getWidth(), h = gr.getHeight()}
    canvasW = 135 --144
    canvasH = 240 --256
    canvas = gr.newCanvas(canvasW, canvasH, "normal")
    sx = win.w / canvasW -- x scale
    sy = win.h / canvasH -- y scale

    accelCandyTime = 0.02
    cr = 13 -- candy radius
    crSmall = 8
    initDelayEnterCandy = 2.2
    delayEnterCandy = initDelayEnterCandy
    delayGameOver = 3
    randomSpecialItem()
    initHP = 6
    hp = initHP
    indexCandy = 0
    maxCandies = 160
    minDelayEnterCandy = 0.7
    points = 0
    timerEnterCandy = 0
    timerGameOver = 0
    endingScoreScreen = false
    timerScoreScreen = 0
    delayScoreScreen = 2.5
    wt = 100 -- wall thickness
    yQuadHearts = 0
    minimumForHighScore = 10

    musicLevel = 0.7
    sfxLevel = 0.6

    MOUSE_LEFT = 1
    MOUSE_RIGHT = 2
    MOUSE_MIDDLE = 3

    STATE_MENU = 1
    STATE_GAME = 2
    STATE_GAME_OVER = 3
    STATE_CREDITS = 4
    STATE_OPTIONS = 5
    STATE_HS = 6

    state = STATE_MENU
    timerZeroGrav = 0
    delayZeroGrav = 5
    zeroGravActivated = false
    paused = false

    --ball = lope.newBody("dynamic", "circle", canvasW / 2, canvasH / 2, 10)
    candies = {}
    font = gr.newFont(dirFonts.."emulogic.ttf", 8)
    fontBig = gr.newFont(dirFonts.."emulogic.ttf", 16)
    gr.setFont(font)

    wallTop     = lope.newBody("static", "rectangle", canvasW / 2, -wt / 2, canvasW, wt)
    wallBottom  = lope.newBody("static", "rectangle", canvasW / 2, canvasH + wt * 0.45, canvasW, wt)
    wallLeft    = lope.newBody("static", "rectangle", -wt / 2, canvasH / 2, wt, canvasH + wt * 2)
    wallRight   = lope.newBody("static", "rectangle", canvasW + wt / 2, canvasH / 2, wt, canvasH + wt * 2)




    imgRedCandy   = gr.newImage(dirImgs.."redCandy.png")
    imgGreenCandy = gr.newImage(dirImgs.."greenCandy.png")
    imgBlueCandy  = gr.newImage(dirImgs.."blueCandy.png")
    imgRedCandySmall   = gr.newImage(dirImgs.."redCandySmall.png")
    imgGreenCandySmall = gr.newImage(dirImgs.."greenCandySmall.png")
    imgBlueCandySmall  = gr.newImage(dirImgs.."blueCandySmall.png")
    imgRing       = gr.newImage(dirImgs.."ring.png")
    imgClock      = gr.newImage(dirImgs.."clock.png")
    imgTimer      = gr.newImage(dirImgs.."timer.png")
    imgRedLeds    = gr.newImage(dirImgs.."redLeds.png")
    imgGreenLeds  = gr.newImage(dirImgs.."greenLeds.png")
    imgBlueLeds   = gr.newImage(dirImgs.."blueLeds.png")
    imgLogo       = gr.newImage(dirImgs.."logo.png")
    imgHearts     = gr.newImage(dirImgs.."hearts.png")
    imgGrass      = gr.newImage(dirImgs.."grass.png")
    imgCredits    = gr.newImage(dirImgs.."credits.png")
    imgOptions    = gr.newImage(dirImgs.."options.png")
    imgHalo       = gr.newImage(dirImgs.."halo.png")
    imgHaloSmall  = gr.newImage(dirImgs.."haloSmall.png")
    imgGrid       = gr.newImage(dirImgs.."grid.png")
    imgGrass:setWrap("repeat", "repeat")
    imgGrid: setWrap("repeat", "repeat")

    quadHearts    = gr.newQuad(0, 0, 23, 7, imgHearts:getWidth(), imgHearts:getHeight())
    quadGrass     = gr.newQuad(0, 0, canvasW, imgGrass:getHeight(), imgGrass:getWidth(), imgGrass:getHeight())
    quadGrid      = gr.newQuad(0, 0, canvasW, canvasH, imgGrid:getWidth(), imgGrid:getHeight())

    animSelected      = k.new(dirImgs.."selected.png", 32, 32, 2, 0.07)
    animSelectedSmall = k.new(dirImgs.."selectedSmall.png", 22, 22, 2, 0.07)
    animSpecial       = k.new(dirImgs.."special.png", 26, 26, 4, 0.07)
    animSpecialSmall  = k.new(dirImgs.."specialSmall.png", 16, 16, 4, 0.07)
    animZG            = k.new(dirImgs.."zg.png", 26, 26, 4, 0.07)
    animZGSmall       = k.new(dirImgs.."zgSmall.png", 16, 16, 4, 0.07)
    animShrinker      = k.new(dirImgs.."shrinker.png", 26, 26, 4, 0.07)
    animShrinkerSmall = k.new(dirImgs.."shrinkerSmall.png", 16, 16, 4, 0.07)

    musicMenu = au.newSource(dirAudio.."musicMenu.ogg", "stream")
    musicGame = au.newSource(dirAudio.."musicGame.ogg", "stream")
    musicGameOver = au.newSource(dirAudio.."musicGameOver.ogg", "stream")

    musicMenu:setLooping(true)
    musicGame:setLooping(true)
    musicGameOver:setLooping(true)

    changeMusicLevel(musicLevel)

    -- clock:

    clock = {
        img = imgClock,
        angle = 0,
        x = canvasW * .15,
        y = 35,
        speed = 20 -- degrees per second
    }

    ring = {
        img = imgRing,
        x = canvasW * .5,
        y = 35,
        radius = 15,
        state = "red" -- capturing red candy
    }

    timer = {
        img = imgTimer,
        initTime = 20, -- seconds
        x = canvasW * .85,
        y = 35,
        speed = 0.7
    }
    timer.time = timer.initTime


    -- menu:
    gooi.setStyle({
        font = fontBig,
        showBorder = false,
        bgColor = colors.softBlue
    })
    gooi.desktopMode()
    gooi.setCanvas(canvas)
    
    btnStart = gooi.newButton({text = "Go"})
    :onRelease(function()
        musicMenu:stop()
        musicGame:play()
        state = STATE_GAME

        gooi.setGroupVisible("menu", false)
    end)
    :setIcon(imgLogo)
    :center()

    lblMenu = gooi.newLabel({text = "The Lord\nof\ncandies"})
    :center()
    --:setOpaque(true)

    btnCredits = gooi.newButton({text = "credits", icon = imgCredits})
    btnCredits.style.font = font
    btnCredits.style.bgColor = colors.orange
    btnCredits:onRelease(function()
        gooi.setGroupVisible("menu", false)
        gooi.setGroupVisible("credits", true)
        state = STATE_CREDITS
    end)

    btnOptions = gooi.newButton({text = "options", icon = imgOptions})
    btnOptions.style.font = font
    btnOptions.style.bgColor = colors.lightGreen
    btnOptions:onRelease(function()
        state = STATE_OPTIONS
        gooi.setGroupVisible("options", true)
        gooi.setGroupVisible("menu", false)
    end)

    panelMenu = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout = "grid 7x1"})
    panelMenu:setRowspan(1, 1, 3)
    panelMenu:setRowspan(4, 1, 2)
    panelMenu:add(
        lblMenu,
        btnStart,
        btnCredits,
        btnOptions
    ):setGroup("menu")

    -- options:
    lblMusic = gooi.newLabel({text = "Music level:"}):left()
    lblMusic.style.font = font
    sliMusic = gooi.newSlider({value = musicLevel}):bg(colors.green)
    lblSFX   = gooi.newLabel({text = "SFX level:"}):left()
    lblSFX.style.font = font
    sliSFX   = gooi.newSlider({value = sfxLevel}):bg(colors.orange)
    panelOptions = gooi.newPanel({
        x = 0,
        y = 0,
        w = canvasW,
        h = canvasH,
        layout = "grid 8x1"
    })

    panelOptions:add(
        lblMusic,
        sliMusic,
        lblSFX,
        sliSFX
    )

    btnBackOpt = gooi.newButton({text = "return"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("menu", true)
        gooi.setGroupVisible("options", false)
    end)
    btnBackOpt.style.font = font

    panelOptions:add(btnBackOpt, "8,1")
    panelOptions:setGroup("options")
    -- game over:

    lblGameOver = gooi.newLabel({text = "Game\nOver", x = 0, y = 30, w = canvasW, h = 40})
    :setGroup("gameover")
    :center()


    -- credits:

    lblCredits = gooi.newLabel({
        text = "Music by\nErick Skiff\n(ericskiff.com)",
    }):center()--:setOpaque(true)

    lblCredits2 = gooi.newLabel({
        text = "Programming:\nThe Lord\nof the Bits"
    }):center()--:setOpaque(true)

    lblCredits3 = gooi.newLabel({
        text = "Art:\nThe Lord\nof the Bits",
    }):center()--:setOpaque(true)

    panelCredits = gooi.newPanel({
        x = 0,
        y = 0,
        w = canvasW,
        h = canvasH,
        layout = "grid 8x1"
    })

    panelCredits:setRowspan(1, 1, 2)
    panelCredits:setRowspan(3, 1, 2)
    panelCredits:setRowspan(5, 1, 2)

    btnBack = gooi.newButton({text = "return"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("menu", true)
        gooi.setGroupVisible("credits", false)
    end)
    btnBack.style.font = font

    panelCredits:add(lblCredits, "1,1")
    panelCredits:add(lblCredits2, "3,1")
    panelCredits:add(lblCredits3, "5,1")
    panelCredits:add(btnBack, "8,1")

    panelCredits:setGroup("credits")
    
    lblCredits.style.font = font
    lblCredits2.style.font = font
    lblCredits3.style.font = font

    -- pause GUI:

    btnContinue = gooi.newButton({text = "continue"}):onRelease(function()
        gooi.setGroupVisible("pause", false)
        paused = not paused
    end):bg(colors.lightGreen)
    btnExit = gooi.newButton({text = "exit"}):bg(colors.red):onRelease(function()
        quit()
    end)

    panelPause = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout = "grid 8x1"})
    panelPause:add(btnContinue, "4,1")
    panelPause:add(btnExit, "5,1")

    btnContinue.style.font = font
    btnExit.style.font = font

    panelPause:setGroup("pause")

    gooi.setGroupVisible("pause", false)
    gooi.setGroupVisible("options", false)
    gooi.setGroupVisible("credits", false)

    -- high scores gooi:
    textHighScoreNames = getTextHSNames()
    textHighScore = getTextHS()

    lblHighScores = gooi.newLabel({
        text = textHighScore
    }):right()
    lblHighScores.style.font = font

    lblHighScores2 = gooi.newLabel({
        text = textHighScoreNames
    }):left()
    lblHighScores2.style.font = font

    panelHS = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout = "grid 8x2"})
    panelHS:setColspan(1, 1, 2)
    panelHS:setColspan(2, 1, 2)
    panelHS:setColspan(4, 1, 2)

    lblPlace = gooi.newLabel({text = ""}):center()
    lblPlace.style.font = font
    panelHS:add(lblPlace)

    lblPoints = gooi.newLabel({text = ""}):center()
    lblPoints.style.font = font
    panelHS:add(lblPoints)

    lblOldTop = gooi.newLabel({text = "old top:"}):center()
    lblOldTop.style.font = font

    panelHS:add(lblOldTop, "4,1")
    panelHS:add(lblHighScores2, "5,1")
    panelHS:add(lblHighScores, "5,2")

    textRecord = gooi.newText()

    panelHS:add(textRecord)
    btnSendRecord = gooi.newButton({
        text = "ok"
    }):onRelease(function(c)
        endingScoreScreen = true
        
        c:setEnabled(false)

        recordToSet.score = points
        recordToSet.name = textRecord:getText()

        saveRecords(records)
        musicGameOver:stop()
        musicMenu:play()

        local newNames  = getTextHSNames()
        local newScores = getTextHS()

        lblHighScores:setText(newScores)
        lblHighScores2:setText(newNames)
    end)

    panelHS:add(btnSendRecord)
    
    panelHS:setGroup("hs")

    gooi.setGroupVisible("hs", false)

    -- music:
    musicMenu:play()
end








--##############################################
--##############################################
-- update
--##############################################
--##############################################

function love.update(dt)
    gooi.update(dt)
    
    if state == STATE_MENU then
    elseif state == STATE_GAME then
        if not paused then
            -- cero gravity:
            if zeroGravActivated then
                timerZeroGrav = timerZeroGrav + dt
                if timerZeroGrav >= delayZeroGrav then
                    timerZeroGrav = 0
                    zeroGravActivated = false
                    WORLD:setGravity(
                        WORLD_GRAVITY.x * WORLD_METER,
                        WORLD_GRAVITY.y * WORLD_METER
                    )
                end
            end


            lope.update(dt)
            k.update(dt)

            timerEnterCandy = timerEnterCandy + dt

            if timerEnterCandy >= delayEnterCandy then
                timerEnterCandy = 0

                if #candies <= maxCandies then
                    local newCandy = candy.new(
                        ma.random(cr, cr + 2),
                        cr,
                        cr,
                        kinds[ma.random(1, #kinds)]
                    )

                    newCandy.body = lope.newBody(
                        "dynamic",
                        "circle",
                        newCandy.x,
                        newCandy.y,
                        newCandy.radius
                    )
                    newCandy.body:setRestitution(0.2)
                    newCandy.body:applyLinearImpulse(0, 30)

                    table.insert(candies, newCandy)
                    indexCandy = indexCandy + 1

                    -- make it special
                    if indexCandy == howManyToSpecial then
                        randomSpecialItem()
                        indexCandy = 0
                        local num = ma.random(1, 3)

                        if num == 1 then
                            newCandy.kind = "special"
                        elseif num == 2 then
                            newCandy.kind = "zg" 
                        else
                            newCandy.kind = "shrinker"
                        end
                    end
                end
            end

            -- update candies:
            for k, candy in ipairs(candies) do
                candy.x, candy.y = candy.body:getX(), candy.body:getY()
                candy.radius = candy.body:getRadius()
            end

            -- clock:
            clock.angle = clock.angle + dt * clock.speed
            if clock.angle >= 360 then
                clock.angle = 0
            end

            -- timer:
            timer.time = timer.time - dt * timer.speed
            if timer.time <= 0 then
                gameover()
            end

            -- candy time:
            delayEnterCandy = delayEnterCandy - dt * accelCandyTime
            if delayEnterCandy <= minDelayEnterCandy then
                delayEnterCandy = minDelayEnterCandy
            end

            -- main collision:
            for i = #candies, 1, -1 do
                local candy = candies[i]

                local dx = candy.x - ring.x
                local dy = candy.y - ring.y
                local hyp = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))

                if hyp < ring.radius then
                    candy.body.body:destroy()
                    table.remove(candies, i)

                    if candy.kind ~= ring.state then
                        if candy.kind == "special" then
                            removeCandyOfColor(ring.state)
                            break
                        elseif candy.kind == "shrinker" then
                            shrinkAll()
                            break
                        elseif candy.kind == "zg" then
                            zeroGrav()
                            break
                        else
                            hp = hp - 1

                            if hp == 0 then
                                gameover()
                                break
                            end

                            yQuadHearts = yQuadHearts + 7
                            quadHearts:setViewport(0, yQuadHearts, 23, 7)
                        end
                    else
                        points = points + 1
                        -- only normal candies recover the time:
                        timer.time = timer.initTime
                    end
                end
            end
        end
    elseif state == STATE_GAME_OVER then
        timerGameOver = timerGameOver + dt
        if timerGameOver >= delayGameOver then
            timerGameOver = 0
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)

            musicGameOver:stop()
            musicMenu:play()
        end
    elseif state == STATE_OPTIONS then
        gooi.update(dt)
        changeMusicLevel(sliMusic:getValue())
    elseif state == STATE_HS then
        if endingScoreScreen then
            timerScoreScreen = timerScoreScreen + dt

            if timerScoreScreen >= delayScoreScreen then
                timerScoreScreen = 0
                endingScoreScreen = false

                gooi.setGroupVisible("hs", false)
                gooi.setGroupVisible("menu", true)
                state = STATE_MENU
                btnSendRecord:setEnabled(true)
            end
        end
    end
end








--##############################################
--##############################################
-- draw
--##############################################
--##############################################

function love.draw()
    gr.setColor(colors.white)
    gr.setCanvas(canvas)

    gr.setColor(colors.black)
    gr.rectangle("fill", 0, 0, canvasW, canvasH)

    if state == STATE_MENU then
        gooi.draw("menu")
        if paused then
            gr.draw(imgGrid, quadGrid, 0, 0)
            gooi.draw("pause")
        end
    elseif state == STATE_CREDITS then
        gooi.draw("credits")
    elseif state == STATE_GAME then
        --debug:
        gr.setFont(font)
        gr.setColor(colors.softBlue)
        gr.rectangle("fill", 0, 0, canvasW, canvasH)
        --lope.draw(ball)
        gr.setColor(colors.white)

        -- grass:
        gr.draw(imgGrass, quadGrass, 0, canvasH - imgGrass:getHeight())

        -- draw candies:
        for k, candy in ipairs(candies) do
            gr.setColor(colors.red)
            if candy.selected then
                gr.setColor(colors.lightGreen)
            end
            --gr.circle("line", candy.x, candy.y, candy.radius)
            gr.setColor(colors.white)
            local img = imgRedCandy
            if candy.kind == "red" then
                img = imgRedCandy
                if candy.small then
                    img = imgRedCandySmall
                end
            elseif candy.kind == "green" then
                img = imgGreenCandy
                if candy.small then
                    img = imgGreenCandySmall
                end
            elseif candy.kind == "blue" then
                img = imgBlueCandy
                if candy.small then
                    img = imgBlueCandySmall
                end
            end

            if candy.selected then
                local anim = animSelected
                if candy.small then anim = animSelectedSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            end

            if candy.kind == "special" then
                local anim = animSpecial
                if candy.small then anim = animSpecialSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            elseif candy.kind == "shrinker" then
                local anim = animShrinker
                if candy.small then anim = animShrinkerSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            elseif candy.kind == "zg" then
                local anim = animZG
                if candy.small then anim = animZGSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            else
                gr.draw(img,
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, img:getWidth() / 2, img:getHeight() / 2)
            end

            if zeroGravActivated then
                local halo = imgHalo
                if candy.small then halo = imgHaloSmall end
                gr.draw(halo,
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, halo:getWidth() / 2, halo:getHeight() / 2
                )
            end

            if mo.isDown(MOUSE_LEFT) then
                local selectedCandy = getSelectedCandy()

                if selectedCandy then
                    gr.line(
                        selectedCandy.x,
                        selectedCandy.y,
                        mo.getX() / sx,
                        mo.getY() / sy)
                end
            end
        end

        -- hearts:
        gr.draw(imgHearts, quadHearts,
            math.ceil(canvasW / 2 - imgHearts:getWidth() / 2),
            3,
            0, 1, 1
        )

        -- clock:
        gr.draw(clock.img,
            math.floor(clock.x),
            math.floor(clock.y),
            0, 1, 1,
            clock.img:getWidth() / 2,
            clock.img:getHeight() / 2
        )

        -- center:
        gr.setColor(colors.black)
        gr.circle(
            "fill",
            math.floor(clock.x), 
            math.floor(clock.y),
            8,
            80
        )

        -- clock arrow:
        gr.setColor(colors.white)
        gr.line(
            math.floor(clock.x),
            math.floor(clock.y),
            clock.x + 12 * math.cos(math.rad(clock.angle - 90)),
            clock.y + 12 * math.sin(math.rad(clock.angle - 90))
        )

        -- goal ring:
        gr.draw(ring.img,
            math.floor(ring.x),
            math.floor(ring.y),
            0, 1, 1,
            ring.img:getWidth() / 2,
            ring.img:getHeight() / 2)

        -- leds:
        gr.draw(getImgLeds(),
            math.floor(ring.x),
            math.floor(ring.y),
            0, 1, 1,
            getImgLeds():getWidth() / 2,
            getImgLeds():getHeight() / 2)

        -- timer:
        gr.draw(timer.img,
            math.floor(timer.x),
            math.floor(timer.y),
            0, 1, 1,
            timer.img:getWidth() / 2,
            timer.img:getHeight() / 2
        )

        -- arc:
        gr.setColor(colors.gold)
        gr.arc(
            "fill",
            math.floor(timer.x), 
            math.floor(timer.y),
            15,
            math.rad(0 + 180),
            math.rad(360 * (timer.time / timer.initTime) + 180),
            80
        )

        -- black center:
        gr.setColor(colors.black)
        gr.circle(
            "fill",
            math.floor(timer.x), 
            math.floor(timer.y),
            8,
            80
        )

        -- time:
        gr.setColor(colors.white)
        local textTime = string.format("%.0f", timer.time)
        gr.print(textTime,
            math.floor(timer.x - font:getWidth(textTime) / 2) - 1,
            math.floor(timer.y - font:getHeight() / 2)
        )

        -- points:
        gr.setColor(colors.white)
        gr.print(
            points,
            math.floor(canvasW / 2 - font:getWidth(tostring(points)) / 2),
            30
        )

        if paused then
            gr.draw(imgGrid, quadGrid, 0, 0)
            gooi.draw("pause")
        end
    elseif state == STATE_GAME_OVER then
        gooi.draw("gameover")
    elseif state == STATE_OPTIONS then
        gooi.draw("options")
    elseif state == STATE_HS then
        gooi.draw("hs")
    end

    gr.setCanvas()
    gr.setColor(colors.white)
    gr.draw(canvas, 0, 0, 0, sx, sy)

    gr.print("FPS: "..fps()..", candy: "..#candies, 5, 5)
    gr.setColor(colors.white)
end







--##############################################
--##############################################
-- love api
--##############################################
--##############################################

function love.keypressed(k)
    if k == "escape" then
        if state == STATE_MENU then
            quit()
        elseif state == STATE_GAME then
            paused = not paused
            gooi.setGroupVisible("pause", paused)
        elseif state == STATE_OPTIONS then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("options", false)
        elseif state == STATE_CREDITS then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("credits", false)
        end
    end

    if state == STATE_HS then
        gooi.keypressed(k)

        if k == "return" and textRecord.hasFocus then
            if not endingScoreScreen then
                btnSendRecord.events.r(btnSendRecord)
            end
        end
    end
end

function love.keyreleased(k)
    if state == STATE_HS then
        gooi.keyreleased(k)
    end
end

function love.textinput(text)
    if state == STATE_HS then
        gooi.textinput(text)
    end
end

function love.mousepressed(x, y, btn)
    if btn == MOUSE_LEFT then
        for k, candy in ipairs(candies) do
            if candy:overIt(mo.getX() / sx, mo.getY() / sy) then
                candy.selected = true
            else
                candy.selected = false
            end
        end
    end

    gooi.pressed()
end

function love.mousemoved(x, y, dx, dy)
    gooi.moved(x, y)
end

function love.mousereleased(x, y, btn)
    if btn == MOUSE_LEFT then
        --debug:
        --ball.body:applyLinearImpulse(ma.random(-500, 500), ma.random(-500, 500))

        local selectedCandy = getSelectedCandy()

        if selectedCandy then
            selectedCandy.body:applyLinearImpulse(
                -(selectedCandy.x - mo.getX() / sx) * selectedCandy.body:getMass() * 6,
                -(selectedCandy.y - mo.getY() / sy) * selectedCandy.body:getMass() * 6
            )
            selectedCandy.selected = false
        end
    end
    
    gooi.released()
end









--##############################################
--##############################################
-- user
--##############################################
--##############################################

function getSelectedCandy()
    for k, candy in ipairs(candies) do
        if candy.selected then
            return candy
        end
    end
end

function getImgLeds()
    local img = imgRedLeds
    ring.state = "red"

    if clock.angle >= 120 then
        img = imgGreenLeds
        ring.state = "green"
    end

    if clock.angle >= 240 then
        img = imgBlueLeds
        ring.state = "blue"
    end

    return img
end

function removeCandyOfColor(color)
    for i = #candies, 1, -1 do
        local candy = candies[i]

        if candy.kind == color then
            candy.body.body:destroy()
            table.remove(candies, i)
        end
    end
end

function shrinkAll()
    for k, candy in ipairs(candies) do
        candy.small = true
        -- backup current velocity:
        local vx, vy = candy.body.body:getLinearVelocity();

        candy.body.body:destroy()
        candy.body = lope.newBody("dynamic", "circle", candy.x, candy.y, crSmall)
        candy.body.body:setLinearVelocity(vx, vy)
    end
end

function changeMusicLevel(level)
    musicMenu:setVolume(level)
    musicGame:setVolume(level)
    musicGameOver:setVolume(level)
end

function gameover()
    if points < minimumForHighScore then
        state = STATE_GAME_OVER
        points = 0
    else
        state = STATE_HS
        gooi.setGroupVisible("hs", true)
        gooi.setGroupVisible("pause", false)

        recordToSet = nil
        local indexPlace = 1
        for k, rec in ipairs(records) do
            if rec.score <= points then
                recordToSet = rec
                break
            end
            indexPlace = indexPlace + 1
        end

        lblPlace:setText(indexPlace..places[indexPlace].." place!")
        lblPoints:setText("score: "..points)
    end

    for i = #candies, 1, -1 do
        local candy = candies[i]

        candy.body.body:destroy()
        table.remove(candies, i)
    end

    timer.time = timer.initTime
    clock.angle = 0
    hp = initHP
    yQuadHearts = 0
    quadHearts:setViewport(0, 0,
        23, 7,
        imgHearts:getWidth(),
        imgHearts:getHeight()
    )

    musicGame:stop()
    musicGameOver:play()
    randomSpecialItem()
    indexCandy = 0
    delayEnterCandy = initDelayEnterCandy
end

function saveRecords(r)
    local stringData = "records = {"

    for k, rec in ipairs(r) do
        stringData = stringData..
        "    {\n"..
        "        score = "..(rec.score)..",\n"..
        "        name = \""..(rec.name).."\"\n"..
        "    },"
    end

    stringData = stringData.."}"

    local compressedData = ma.compress(stringData, "gzip")

    local writeOK = fs.write("records.lord", compressedData)
end

function getTextHSNames()
    local text = ""

    local dataHighScores, size = fs.read("records.lord")
    decompressed = ma.decompress(dataHighScores, "gzip")

    loadstring(decompressed)() --<<----- stored in global "records"

    local index = 1
    for k, rec in ipairs(records) do
        text = text..
        index.." "..rec.name.."\n"
        index = index + 1
    end

    return text
end

function getTextHS()
    local text = ""

    for k, rec in ipairs(records) do
        text = text..rec.score.."\n"
    end

    return text
end

function randomSpecialItem()
    howManyToSpecial = ma.random(5, 10)
end

function zeroGrav()
    WORLD:setGravity(0, 0)
    zeroGravActivated = true
    timerZeroGrav = 0
end

function fps()
    return love.timer.getFPS()
end

function quit()
    love.event.quit()
end
